// define forward and backward dct functions and pointers, actual code version from Xvid project

#ifndef _FDCT_H_
#define _FDCT_H_

extern "C" {

typedef void (fdctFunc)(short * const block);
typedef fdctFunc* fdctFuncPtr;	

extern "C" fdctFuncPtr fdct;

//fdctFunc fdct_int32;
fdctFunc fdct_mmx;
fdctFunc fdct_altivec;
fdctFunc fdct_sse2;

#endif 

#ifndef _IDCT_H_
#define _IDCT_H_


typedef void (idctFunc)(short * const block);
typedef idctFunc* idctFuncPtr;	

extern "C" idctFuncPtr idct;

//idctFunc idct_int32;
idctFunc idct_mmx;
idctFunc idct_xmm;				// sse verson
idctFunc idct_sse2;
idctFunc idct_altivec;


#define DO_ADJUST(pwa) __asm { \
	__asm mov eax, pwa \
	__asm mov esi, pFactors						/* our parms, mult factors */ \
	\
	__asm movq mm0, qword ptr[eax+0*16]			/* low word */ \
	__asm movq mm1, qword ptr[eax+0*16+8]		/* high word */ \
	__asm pmullw mm0, qword ptr[esi+0*16]		/* mult by parm factor */ \
	__asm pmullw mm1, qword ptr[esi+0*16+8] \
	__asm psraw mm0, 3							/* scale by 1/8 */ \
	__asm psraw mm1, 3 \
	__asm movq qword ptr[eax+0*16], mm0			/* and put back into work */ \
	__asm movq qword ptr[eax+0*16+8], mm1 \
	\
	__asm movq mm0, qword ptr[eax+1*16]			/* low word	*/ \
	__asm movq mm1, qword ptr[eax+1*16+8]		/* high word */ \
	__asm pmullw mm0, qword ptr[esi+1*16]		/* mult by parm factor */ \
	__asm pmullw mm1, qword ptr[esi+1*16+8] \
	__asm psraw mm0, 3							/* scale by 1/8 */ \
	__asm psraw mm1, 3 \
	__asm movq qword ptr[eax+1*16], mm0			/* and put back into work */ \
	__asm movq qword ptr[eax+1*16+8], mm1 \
	\
	__asm movq mm0, qword ptr[eax+2*16]			/* low word	*/ \
	__asm movq mm1, qword ptr[eax+2*16+8]		/* high word */ \
	__asm pmullw mm0, qword ptr[esi+2*16]		/* mult by parm factor */ \
	__asm pmullw mm1, qword ptr[esi+2*16+8] \
	__asm psraw mm0, 3							/* scale by 1/8 */ \
	__asm psraw mm1, 3 \
	__asm movq qword ptr[eax+2*16], mm0			/* and put back into work */ \
	__asm movq qword ptr[eax+2*16+8], mm1 \
	\
	__asm movq mm0, qword ptr[eax+3*16]			/* low word */ \
	__asm movq mm1, qword ptr[eax+3*16+8]		/* high word */ \
	__asm pmullw mm0, qword ptr[esi+3*16]		/* mult by parm factor */ \
	__asm pmullw mm1, qword ptr[esi+3*16+8] \
	__asm psraw mm0, 3							/* scale by 1/8 */ \
	__asm psraw mm1, 3 \
	__asm movq qword ptr[eax+3*16], mm0			/* and put back into work */ \
	__asm movq qword ptr[eax+3*16+8], mm1 \
	\
	__asm movq mm0, qword ptr[eax+4*16]			/* low word */ \
	__asm movq mm1, qword ptr[eax+4*16+8]		/* high word */ \
	__asm pmullw mm0, qword ptr[esi+4*16]		/* mult by parm factor */ \
	__asm pmullw mm1, qword ptr[esi+4*16+8] \
	__asm psraw mm0, 3							/* scale by 1/8 */ \
	__asm psraw mm1, 3 \
	__asm movq qword ptr[eax+4*16], mm0			/* and put back into work */ \
	__asm movq qword ptr[eax+4*16+8], mm1 \
	\
	__asm movq mm0, qword ptr[eax+5*16]			/* low word	*/ \
	__asm movq mm1, qword ptr[eax+5*16+8]		/* high word */ \
	__asm pmullw mm0, qword ptr[esi+5*16]		/* mult by parm factor */ \
	__asm pmullw mm1, qword ptr[esi+5*16+8] \
	__asm psraw mm0, 3							/* scale by 1/8 */ \
	__asm psraw mm1, 3 \
	__asm movq qword ptr[eax+5*16], mm0			/* and put back into work */ \
	__asm movq qword ptr[eax+5*16+8], mm1 \
	\
	__asm movq mm0, qword ptr[eax+6*16]			/* low word */ \
	__asm movq mm1, qword ptr[eax+6*16+8]		/* high word */ \
	__asm pmullw mm0, qword ptr[esi+6*16]		/* mult by parm factor */ \
	__asm pmullw mm1, qword ptr[esi+6*16+8] \
	__asm psraw mm0, 3							/* scale by 1/8 */ \
	__asm psraw mm1, 3 \
	__asm movq qword ptr[eax+6*16], mm0			/* and put back into work */ \
	__asm movq qword ptr[eax+6*16+8], mm1 \
	\
	__asm movq mm0, qword ptr[eax+7*16]			/* low word	*/ \
	__asm movq mm1, qword ptr[eax+7*16+8]		/* high word */ \
	__asm pmullw mm0, qword ptr[esi+7*16]		/* mult by parm factor */ \
	__asm pmullw mm1, qword ptr[esi+7*16+8] \
	__asm psraw mm0, 3							/* scale by 1/8 */ \
	__asm psraw mm1, 3 \
	__asm movq qword ptr[eax+7*16], mm0			/* and put back into work */ \
	__asm movq qword ptr[eax+7*16+8], mm1 \
}
#define DO_ADJUSTD(pwa) __asm { \
	__asm mov eax, pwa \
	__asm mov esi, pFactors						/* our parms, mult factors */ \
	\
	__asm movq mm0, qword ptr[eax+0*16]			/* low word */ \
	__asm movq mm1, qword ptr[eax+0*16+8]		/* high word */ \
	__asm pand mm0, qword ptr[esi+0*16]		/* mask by parm factor */ \
	__asm pand mm1, qword ptr[esi+0*16+8] \
	__asm movq qword ptr[eax+0*16], mm0			/* and put back into work */ \
	__asm movq qword ptr[eax+0*16+8], mm1 \
	\
	__asm movq mm0, qword ptr[eax+1*16]			/* low word	*/ \
	__asm movq mm1, qword ptr[eax+1*16+8]		/* high word */ \
	__asm pand mm0, qword ptr[esi+1*16]		/* mask by parm factor */ \
	__asm pand mm1, qword ptr[esi+1*16+8] \
	__asm movq qword ptr[eax+1*16], mm0			/* and put back into work */ \
	__asm movq qword ptr[eax+1*16+8], mm1 \
	\
	__asm movq mm0, qword ptr[eax+2*16]			/* low word	*/ \
	__asm movq mm1, qword ptr[eax+2*16+8]		/* high word */ \
	__asm pand mm0, qword ptr[esi+2*16]		/* mask by parm factor */ \
	__asm pand mm1, qword ptr[esi+2*16+8] \
	__asm movq qword ptr[eax+2*16], mm0			/* and put back into work */ \
	__asm movq qword ptr[eax+2*16+8], mm1 \
	\
	__asm movq mm0, qword ptr[eax+3*16]			/* low word */ \
	__asm movq mm1, qword ptr[eax+3*16+8]		/* high word */ \
	__asm pand mm0, qword ptr[esi+3*16]		/* mask by parm factor */ \
	__asm pand mm1, qword ptr[esi+3*16+8] \
	__asm movq qword ptr[eax+3*16], mm0			/* and put back into work */ \
	__asm movq qword ptr[eax+3*16+8], mm1 \
	\
	__asm movq mm0, qword ptr[eax+4*16]			/* low word */ \
	__asm movq mm1, qword ptr[eax+4*16+8]		/* high word */ \
	__asm pand mm0, qword ptr[esi+4*16]		/* mask by parm factor */ \
	__asm pand mm1, qword ptr[esi+4*16+8] \
	__asm movq qword ptr[eax+4*16], mm0			/* and put back into work */ \
	__asm movq qword ptr[eax+4*16+8], mm1 \
	\
	__asm movq mm0, qword ptr[eax+5*16]			/* low word	*/ \
	__asm movq mm1, qword ptr[eax+5*16+8]		/* high word */ \
	__asm pand mm0, qword ptr[esi+5*16]		/* mask by parm factor */ \
	__asm pand mm1, qword ptr[esi+5*16+8] \
	__asm movq qword ptr[eax+5*16], mm0			/* and put back into work */ \
	__asm movq qword ptr[eax+5*16+8], mm1 \
	\
	__asm movq mm0, qword ptr[eax+6*16]			/* low word */ \
	__asm movq mm1, qword ptr[eax+6*16+8]		/* high word */ \
	__asm pand mm0, qword ptr[esi+6*16]		/* mask by parm factor */ \
	__asm pand mm1, qword ptr[esi+6*16+8] \
	__asm movq qword ptr[eax+6*16], mm0			/* and put back into work */ \
	__asm movq qword ptr[eax+6*16+8], mm1 \
	\
	__asm movq mm0, qword ptr[eax+7*16]			/* low word	*/ \
	__asm movq mm1, qword ptr[eax+7*16+8]		/* high word */ \
	__asm pand mm0, qword ptr[esi+7*16]		/* mask by parm factor */ \
	__asm pand mm1, qword ptr[esi+7*16+8] \
	__asm movq qword ptr[eax+7*16], mm0			/* and put back into work */ \
	__asm movq qword ptr[eax+7*16+8], mm1 \
}

}
#endif 
